/**
 * This file holds the Servoy basic plugin functionalities i.e displaying plugin name, image for plugin
 * and plugin initialization
 */

package mf.plugins.MfCreditCard;


import java.beans.PropertyChangeEvent;
import java.net.URL;
import java.util.Properties;

import javax.swing.Icon;
import javax.swing.ImageIcon;

import com.servoy.j2db.plugins.IClientPlugin;
import com.servoy.j2db.plugins.IClientPluginAccess;
import com.servoy.j2db.plugins.PluginException;
import com.servoy.j2db.scripting.IScriptable;

/**
 * @author prasady
 * 
 * @since 08/20/2013
 *
 */
public class MfCreditCardPlugin implements IClientPlugin {
	
	//Plugin name that displays in Servoy
	public static final String PLUGIN_NAME = "MFCreditCardPlugin";
	private MFCreditCardPluginProvider impl;
	
	/* (non-Javadoc)
	 * @see com.servoy.j2db.plugins.IPlugin#getProperties()
	 */
	@Override
	public Properties getProperties() {
		
		Properties prop = new Properties();
		prop.put(DISPLAY_NAME, getName());
		
		return prop;
	}

	/* (non-Javadoc)
	 * @see com.servoy.j2db.plugins.IPlugin#load()
	 */
	@Override
	public void load() throws PluginException {
		
	}

	/* (non-Javadoc)
	 * @see com.servoy.j2db.plugins.IPlugin#unload()
	 */
	@Override
	public void unload() throws PluginException {

	    impl = null;

	}

	/* (non-Javadoc)
	 * @see java.beans.PropertyChangeListener#propertyChange(java.beans.PropertyChangeEvent)
	 */
	@Override
	public void propertyChange(PropertyChangeEvent arg0) {
		

	}

	/* (non-Javadoc)
	 * @see com.servoy.j2db.scripting.IScriptableProvider#getScriptObject()
	 */
	@Override
	public IScriptable getScriptObject() {
		
		//Initializing MFCreditCardPluginProvider instance
		if(impl == null) {
			
			impl = new MFCreditCardPluginProvider();
		}
		
		return impl;
	}

	/* (non-Javadoc)
	 * @see com.servoy.j2db.plugins.IClientPlugin#getImage()
	 */
	@Override
	public Icon getImage() {
		
		//Gets the image for credit card plugin
		URL localURL = getClass().getResource("images/MfCreditCard.png");
		
	    if (localURL != null) {
	    	
	    	return new ImageIcon(localURL);
	    }
	    
	    return null;

	}

	/* (non-Javadoc)
	 * @see com.servoy.j2db.plugins.IClientPlugin#getName()
	 */
	@Override
	public String getName() {
		
		if(PLUGIN_NAME != null)
			return PLUGIN_NAME;
		else
			return null;
	}

	/* (non-Javadoc)
	 * @see com.servoy.j2db.plugins.IClientPlugin#initialize(com.servoy.j2db.plugins.IClientPluginAccess)
	 */
	@Override
	public void initialize(IClientPluginAccess app) throws PluginException {
		
		
	}
}
